using System;
using System.Threading;

namespace ThreadInterruptAndAbort
{
	/// <summary>
	/// Summary description for TestCode.
	/// </summary>
	public class TestCode
	{
		public static void method1()
		{
			// A thread (unfortunately) is interrupted
			// only if it is blocked on a sleep, wait
			// or join. If it is busy, it is not interrupted.
			try
			{
				string str = null;
				for(int i = 0; i < 10000; i++)
				{
					str += "value is " + i;
				}

				Console.WriteLine("Going into sleep");
				Thread.Sleep(60000);
			}
			catch(ThreadInterruptedException ex)
			{
				Console.WriteLine(ex.StackTrace);
			}
			catch(ThreadAbortException ex)
			{
				Console.WriteLine(ex.StackTrace);

				// The ThreadAbortException is rethrown here
				// automatically.

				// Here is some thing that is possible,
				// but use your judgement.
				//Thread.ResetAbort();
			}

			Console.WriteLine("Method 1 continues now");
		}

		public static void Main()
		{
			Thread th1 = new Thread(new ThreadStart(method1));

			th1.Start();
			Thread.Sleep(1000);
			Console.WriteLine("Let's interrupt the thread");

			th1.Interrupt();

			Console.WriteLine("Press to continue");
			Console.ReadLine();
			Thread th2 = new Thread(new ThreadStart(method1));

			th2.Start();
			Thread.Sleep(1000);
			Console.WriteLine("Let's Abort the thread");

			th2.Abort();
		}
	}
}
